﻿using System;
using System.Security.Cryptography;
using System.Text;

namespace PasswordCheck
{
    class CryptRSA
    {
        /// 公開鍵暗号で文字列を暗号化
        /// tex 平文の文字列
        /// publickey   公開鍵
        /// returns 暗号化された文字列
        public static string Encrypt(string text, string publickey)
        {
            using (RSACryptoServiceProvider rsa = new RSACryptoServiceProvider())
            {
                rsa.FromXmlString(publickey);

                byte[] data = Encoding.UTF8.GetBytes(text);

                data = rsa.Encrypt(data, false);

                return Convert.ToBase64String(data);
            }
        }

        /// 秘密鍵で暗号文を復号する
        /// tex 暗号化された文字列
        /// privatekey   秘密鍵
        /// returns 復号された文字列
        public static string Decrypt(string cipher, string privatekey)
        {
            using (RSACryptoServiceProvider rsa = new RSACryptoServiceProvider())
            {
                rsa.FromXmlString(privatekey);

                byte[] data = Convert.FromBase64String(cipher);

                data = rsa.Decrypt(data, false);

                return Encoding.UTF8.GetString(data);
            }
        }

    }
}