﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PasswordCheck
{
    public partial class AlertForm : Form
    {
        const int PADDING = 20;
        const int CELL_HIGHT = 90;
        const int LABEL_WIDTH = 530;

        //*************************************************************************************************
        //つかんで動かせるようにする関係
        //*************************************************************************************************
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();

        //*************************************************************************************************
        //タイトルパネルをつかんで動かせるようにする関係
        //*************************************************************************************************
        private void header_label_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //マウスのキャプチャを解除
                ReleaseCapture();
                //タイトルバーでマウスの左ボタンが押されたことにする
                SendMessage(Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);
            }
        }


        public AlertForm(List<DetectResult> kResults)
        {
            InitializeComponent();

            int count = 0;

            foreach (DetectResult kRlt in kResults)
            {
                AddResultControl(kRlt, count);
                count++;
            }

            Label lbl = new Label();
            lbl.Location = new Point(PADDING,  count * CELL_HIGHT);
            lbl.Size = new System.Drawing.Size(LABEL_WIDTH, 80);
            lbl.Text = "\n上記の事項が検出されました。取扱い可能な区分かを確認してから送信してください。";
            //lbl.Font = new Font("メイリオ", 14.25);
            lbl.Font = new Font("メイリオ", (float)14.25, FontStyle.Bold);
            lbl.BorderStyle = BorderStyle.None;
            this.panel1.Controls.Add(lbl);

            Button btn = new Button();
            btn.Location = new Point(PADDING * 6 + LABEL_WIDTH, PADDING * 2 + count * CELL_HIGHT);
            btn.Text = "閉じる";
            btn.Name = "bntSend";
            btn.Size = new System.Drawing.Size(75, 33);
            btn.DialogResult = DialogResult.OK;

            this.panel1.Controls.Add(btn);
        }

        private void AlertForm_Shown(object sender, EventArgs e)
        {

        }

        private void AddResultControl(DetectResult kResult, int count)
        {
            //MessageBox.Show(count.ToString());
            try
            {
                {
                    //アラート本文
                    Label lbl = new Label();
                    lbl.Location = new Point(PADDING, PADDING + count * CELL_HIGHT);
                    lbl.Size = new System.Drawing.Size(LABEL_WIDTH, 80);
                    lbl.Text = "[添付ファイル名]　：　" + kResult.fName + "\n" + "[検出位置]　：　" + kResult.pStr;
                    lbl.Font = new Font("メイリオ", (float)12, FontStyle.Bold);
                    lbl.BorderStyle = BorderStyle.FixedSingle;
                    lbl.TextAlign = ContentAlignment.MiddleLeft;
                    this.panel1.Controls.Add(lbl);
                }

                //アラート画像
                if (kResult.imgEx)
                {
                    PictureBox picbox = new PictureBox();
                    picbox.Location = new Point(PADDING * 2 + LABEL_WIDTH, PADDING + count * CELL_HIGHT);
                    picbox.Size = new System.Drawing.Size(200, 80);

                    System.IO.FileStream fs = new System.IO.FileStream(ThisAddIn.WORK_FOLDER_PATH + kResult.imgName, System.IO.FileMode.Open, System.IO.FileAccess.Read);
                    picbox.Image = Image.FromStream(fs);
                    fs.Close();
                    //picbox.Image = Image.FromFile(ThisAddIn.WORK_FOLDER_PATH + kResult.imgName);
                    picbox.BorderStyle = BorderStyle.FixedSingle;
                    picbox.SizeMode = PictureBoxSizeMode.CenterImage;
                    this.panel1.Controls.Add(picbox);
                }
                else
                {
                    Label lbl = new Label();
                    lbl.Location = new Point(PADDING * 2 + LABEL_WIDTH, PADDING + count * CELL_HIGHT);
                    lbl.Size = new System.Drawing.Size(200, 80);
                    lbl.Text = "[画像無し]" + "\n" + "[取扱区分標記疑い]" + "\n" + kResult.kword;
                    lbl.Font = new Font("メイリオ", (float)12, FontStyle.Bold);
                    lbl.BorderStyle = BorderStyle.FixedSingle;
                    lbl.TextAlign = ContentAlignment.TopCenter;
                    this.panel1.Controls.Add(lbl);
                }
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.ToString());
            }
        }

        private void AlertForm_Load(object sender, EventArgs e)
        {

        }
    }
}
