﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PasswordCheck
{
    public partial class ExclusionForm : Form
    {

        //*************************************************************************************************
        //つかんで動かせるようにする関係
        //*************************************************************************************************
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();

        //*************************************************************************************************
        //タイトルラベルをつかんで動かせるようにする関係
        //*************************************************************************************************
        private void lbl_Header_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //マウスのキャプチャを解除
                ReleaseCapture();
                //タイトルバーでマウスの左ボタンが押されたことにする
                SendMessage(Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);
            }
        }


        public string SelectedOption { get; private set; }
        public PassResultStatus FileType { get; private set; }

        public ExclusionForm()
        {
            InitializeComponent();
            this.Shown += new System.EventHandler(this.Form_elearn_Shown);
        }
        private void Form_elearn_Shown(object sender, EventArgs e)
        {
            //MessageBox.Show("shown");
            // ラジオボタンの初期化
            radioButton1.Checked = false;
            radioButton2.Checked = false;
            radioButton3.Checked = false;

            // プロパティの初期化
            SelectedOption = string.Empty;
            FileType = PassResultStatus.Undefined; // None は初期状態や未選択を表すための値です
        }

        private void btn_elearn_ok_Click(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                //MessageBox.Show("type1");
                SelectedOption = "[人事評価記録]";
                FileType = PassResultStatus.Elearning;
            }
            else if (radioButton2.Checked)
            {
                //MessageBox.Show("type2");
                SelectedOption = "[ｅラーニング等]";
                FileType = PassResultStatus.Evaluation;
            }
            else if (radioButton3.Checked)
            {
                //MessageBox.Show("type3");
                SelectedOption = "[調査等のデータ]";
                FileType = PassResultStatus.SurveyResult;
            }
            else if (radioButton4.Checked)
            {
                SelectedOption = "";//設定解除
                FileType = PassResultStatus.Undefined;
            }
            else
            {
                //MessageBox.Show("");
                this.DialogResult = DialogResult.Cancel; // ダイアログ結果をCancelに設定
                this.Close(); // ダイアログを閉じる
            }


            this.DialogResult = DialogResult.OK; // ダイアログ結果をOKに設定
            this.Close(); // ダイアログを閉じる
        }

        private void btn_elearn_cancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel; // ダイアログ結果をCancelに設定
            this.Close(); // ダイアログを閉じる
        }
    }
}
