﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace PasswordCheck
{
    public partial class Form_prog : Form
    {
        //*************************************************************************************************
        //つかんで動かせるようにする関係
        //*************************************************************************************************
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();

        //*************************************************************************************************
        //タイトルラベルをつかんで動かせるようにする関係
        //*************************************************************************************************
        private void lbl_Header_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //マウスのキャプチャを解除
                ReleaseCapture();
                //タイトルバーでマウスの左ボタンが押されたことにする
                SendMessage(Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);
            }
        }

        // コンストラクタ
        public Form_prog()
        {
            InitializeComponent();
        }

        // プログレスバーの進捗を更新するメソッド
        public void UpdateProgress(int progress)
        {
            // InvokeRequiredをチェックし、UIスレッドで実行
            if (this.InvokeRequired)
            {
                this.Invoke(new Action<int>(UpdateProgress), progress);
            }
            else
            {
                try
                {
                    // ここでプログレスバーのValueを更新します
                    // progressBar1はデザイナーでフォームに追加したプログレスバーの名前と仮定します
                    progressBar1.Value = progress;
                }
                catch {
                    //とりあえず８０に仮置き
                    progressBar1.Value = 80;
                }
            }
        }

        // プログレスバーの進捗を更新するメソッド
        public void UpdateSecondaryProgress(int progress)
        {
            // InvokeRequiredをチェックし、UIスレッドで実行
            if (this.InvokeRequired)
            {
                this.Invoke(new Action<int>(UpdateSecondaryProgress), progress);
            }
            else
            {
                try
                {
                    // ここでプログレスバーのValueを更新します
                    // progressBar1はデザイナーでフォームに追加したプログレスバーの名前と仮定します
                    progressBar2.Value = progress;
                }
                catch
                {
                    //とりあえず８０に仮置き
                    progressBar2.Value = 80;
                }
            }
        }

        // 状態表示を更新するメソッド
        public void UpdateStatus(string status)
        {
            if (InvokeRequired)
            {
                Invoke(new Action<string>(UpdateStatus), status);
                return;
            }
            lbl_prog.Text = status; // label1はフォームデザイナーで追加したラベルの名前とする
        }

        // プログレスフォームをクローズするメソッド
        public void CloseForm()
        {
            if (InvokeRequired)
            {
                Invoke(new Action(CloseForm));
                return;
            }
            // 安全にフォームを閉じる
            this.Close();
        }

    }
}
