﻿using Outlook = Microsoft.Office.Interop.Outlook;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;
using System.Net.Http;
using System.Net;
using Extentions;

namespace PasswordCheck
{
    public partial class ResultForm : Form
    {
        private Microsoft.Office.Interop.Outlook.Application outlookApp;
        private Outlook.MailItem mail;
        private PasswordChecker checker;
        public ResultHandler resultHundler;

        private AlertForm aform;
        private ExclusionForm form_elearn;
        //private Form_prog progressForm;


        private Boolean senderLoaded = false;
        private Boolean sendCheck;

        //*************************************************************************************************
        //つかんで動かせるようにする関係
        //*************************************************************************************************
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        private static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();

        //*************************************************************************************************
        //タイトルパネルをつかんで動かせるようにする関係
        //*************************************************************************************************
        private void pnl_Header_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //マウスのキャプチャを解除
                ReleaseCapture();
                //タイトルバーでマウスの左ボタンが押されたことにする
                SendMessage(Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);
            }
        }
        //*************************************************************************************************
        //タイトルラベルをつかんで動かせるようにする関係
        //*************************************************************************************************
        private void label_Header_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //マウスのキャプチャを解除
                ReleaseCapture();
                //タイトルバーでマウスの左ボタンが押されたことにする
                SendMessage(Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);
            }
        }

        //*************************************************************************************************
        //コンストラクタ　フォームの初期設定
        //*************************************************************************************************
        public ResultForm(Microsoft.Office.Interop.Outlook.Application AppOutlook, Outlook.MailItem mail)
        {
            InitializeComponent();

            this.mail = mail;
            this.outlookApp = AppOutlook;

            this.resultHundler = new ResultHandler();
            this.checker = new PasswordChecker(resultHundler);
            //this.progressForm = new Form_prog();

            try
            {
                this.nameTextBox.Text = Properties.Settings.Default.senderName;
                this.telTextBox0.Text = Properties.Settings.Default.senderTle0;
                this.telTextBox1.Text = Properties.Settings.Default.senderTel;
                this.telTextBox2.Text = Properties.Settings.Default.senderTel2;
                if(this.telTextBox0.Text == "")
                {
                    this.telTextBox0.Text = "8";
                }
                //MessageBox.Show("読み込み");

            }
            catch
            {
                MessageBox.Show("送信者情報の設定が取得できませんでした。");
                this.nameTextBox.Text = "";
                this.telTextBox1.Text = "";
                this.telTextBox2.Text = "";
            }

            senderLoaded = true;

        }

        //*************************************************************************************************
        //最初にフォームが表示されたとき
        //*************************************************************************************************
        private void ResultForm_Shown(object sender, EventArgs e)
        {
            this.sendBtn.Enabled = false; //送信ボタン無効


            this.label1.Text = "一時ファイル削除中";
            this.label1.Update();
            ClearWorkDir(); //一時作業フォルダクリア

            this.label1.Text = "添付ファイルを取得中";
            this.label1.Update();
            foreach (Outlook.Attachment file in mail.Attachments)
            {
                try
                {
                    file.SaveAsFile(ThisAddIn.WORK_FOLDER_PATH + file.FileName);
                    resultHundler.AddPassResult(fileName: file.FileName);
                    //resultHundler.AddPassResult(new PassResult(fileName: file.FileName,
                    //                                            type: checker.GetFileType(ThisAddIn.WORK_FOLDER_PATH + file.FileName)));
                }
                catch (System.Exception fileSaveE)
                {// 埋め込みオブジェクトを保存しようとすると多分エラー出るので、ステータスを「Object」に設定して次へ
                    resultHundler.AddPassResult(fileName: file.FileName, rStatus: PassResultStatus.Object);
                }
            }

            this.label1.Text = "添付ファイルを確認中";
            this.label1.Update();
            ////**************************************************
            ////Zip対応
            ////検索処理開始
            ////**************************************************
            checker.StartSearch();

            //**************************************************
            //送信可否確認
            //**************************************************
            this.CheckSendState();

            //**************************************************
            //グリッドビューの表示更新
            //**************************************************
            this.ViewResult();
        }

        //*************************************************************************************************
        //パスワード検証ボタンを押したとき
        //*************************************************************************************************
        private void btn_PassCheck_Click(object sender, EventArgs e)
        {

            //**************************************************
            //グリッドビューへの入力を内部データへ反映（現在はパスワードのみ）
            //**************************************************
            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                // パスワード不明またはパスワード保護Zipの行の場合
                if ((PassResultStatus)dataGridView1.Rows[i].Cells[4].Value == PassResultStatus.Incorrect || (PassResultStatus)dataGridView1.Rows[i].Cells[4].Value == PassResultStatus.ProtecteZip)
                {
                    //該当行の入力パスワードにてresultリストを更新
                    resultHundler.GridRowToResults(dataGridView1.Rows[i]);
                }
            }

            ////**************************************************
            ////パスワード付きZip対応
            ////検索処理開始
            ////**************************************************
            checker.StartSearch();

            //**************************************************
            //送信可否確認
            //**************************************************
            this.CheckSendState();

            //**************************************************
            //グリッドビューの表示更新
            //**************************************************
            this.ViewResult();
        }

        //*************************************************************************************************
        //パスワード通知不要ファイルボタン
        //*************************************************************************************************
        private void btn_elearn_Click(object sender, EventArgs e)
        {

            // チェックがなければ動作しない
            Boolean check = false;
            for (int i = 0; i < dataGridView1.RowCount; i++)
            {
                //チェックが入っている行があれば
                if ((Boolean)dataGridView1.Rows[i].Cells[1].Value == true)
                {
                    check = true;
                    break;
                }
            }
            if (check == false)
            {
                MessageBox.Show("設定対象のファイルを選択してください。");
                return;
            }

                // formElearnInstanceがnullの場合のみ新しいインスタンスを作成
                if (form_elearn == null)
            {
                form_elearn = new ExclusionForm();
            }
            if (form_elearn.ShowDialog() == DialogResult.OK)
            {
                // グリッドの行ごとに処理
                List<PassResult> passResults = resultHundler.GetPassResults();
                for (int i = 0; i < dataGridView1.RowCount; i++)
                {
                    //チェックが入っていない行はとばす
                    if ((Boolean)dataGridView1.Rows[i].Cells[1].Value == false)
                    {
                        continue;
                    }

                    // 対象外を選択してＯＫを押した場合（解除する場合）
                    if (form_elearn.FileType == PassResultStatus.Undefined)
                    {
                        if (passResults[i].passStatus == PassResultStatus.Elearning || passResults[i].passStatus == PassResultStatus.Evaluation || passResults[i].passStatus == PassResultStatus.SurveyResult) // E-learning指定済みの場合は解除
                        {
                            // 非対応ファイル
                            if (passResults[i].fType == FileType.Unknown)
                            {
                                passResults[i].passStatus = PassResultStatus.Unknown; // ステータスを非対応に設定
                                passResults[i].pwd = "";
                            }
                            else // パスワード付きファイル
                            {
                                passResults[i].passStatus = PassResultStatus.Incorrect; // ステータスをパスワード不明
                                passResults[i].pwd = "";
                            }
                        }

                    }
                    else
                    {
                        //パスワード不明ファイルか非対応ファイルのみE-learning指定可能
                        if (passResults[i].passStatus == PassResultStatus.Incorrect || passResults[i].passStatus == PassResultStatus.Unknown || passResults[i].passStatus == PassResultStatus.Elearning || passResults[i].passStatus == PassResultStatus.Evaluation || passResults[i].passStatus == PassResultStatus.SurveyResult)
                        {
                            passResults[i].passStatus = form_elearn.FileType; // ステータスをelarning等に変更
                            passResults[i].pwd = form_elearn.SelectedOption; // パスワード標記をelarning等に変更
                        }
                    }
                }

                //送信可否確認
                this.CheckSendState();
                //結果表示
                this.ViewResult();
                passResults = null;

            }
        }

        //*************************************************************************************************
        //実行ボタンを押したとき
        //*************************************************************************************************
        //private void actionBtn_Click(object sender, EventArgs e)
        //{
        //    switch (this.actionComboBox.SelectedIndex)
        //    {
        //        //*********************************************************************
        //        //入力したパスワードを検証
        //        //*********************************************************************
        //        case 0:

        //        //*********************************************************************
        //        //選択したパスワードを「良く使うパスワード」に登録
        //        //*********************************************************************
        //        case 2:
        //            List<string> newPwd = new List<string>();
        //            for (int i = 0; i < dataGridView1.Rows.Count; i++)
        //            {
        //                //チェックボックスがチェックされている行について、パスワードが空文字でなければ
        //                if ((Boolean)dataGridView1.Rows[i].Cells[1].Value == true && dataGridView1.Rows[i].Cells[3].Value.ToString() != "")
        //                {
        //                    //パスワードを登録
        //                    newPwd.Add(dataGridView1.Rows[i].Cells[3].Value.ToString());
        //                }
        //            }
        //            checker.AddPassword(newPwd);
        //            //this.label1.Text = newPwd.Count.ToString() + "件のパスワードを「良く使うパスワード」に追加しました。";
        //            MessageBox.Show(newPwd.Count.ToString() + "件のパスワードを「良く使うパスワード」に追加しました。");

        //            // 選択状態を「入力したパスワードを検証」に戻す
        //            this.actionComboBox.SelectedIndex = 0;

        //            break;


        //        //*********************************************************************
        //        //「良く使うパスワード」を全て削除
        //        //*********************************************************************
        //        case 3:
        //            checker.ClearPassword();
        //            //this.label1.Text = "「良く使うパスワード」を削除しました。";
        //            MessageBox.Show("「良く使うパスワード」を削除しました。");
        //            // 選択状態を「入力したパスワードを検証」に戻す
        //            this.actionComboBox.SelectedIndex = 0;
        //            break;

        //    }
        //}



        //*************************************************************************************************
        //送信可否確認
        //*************************************************************************************************
        private void CheckSendState()
        {
            List<PassResult> results = resultHundler.GetPassResults();

            this.label1.Text = "送信できます。\r\n送信者情報を確認し、送信してください。";

            sendCheck = true;
            this.dataGridView1.Columns[1].Visible = false;
            this.btn_PassCheck.Visible = false;
            this.btn_elearn.Visible = false;
          
            foreach (PassResult result in results)
            {
                // 全てパスワードなしファイルのではない場合は、操作関係ボタンを表示
                if (!(result.passStatus == PassResultStatus.NonePassword || (result.passStatus==PassResultStatus.Unzipped && result.pwd == "")))
                {
                    this.dataGridView1.Columns[1].Visible = true;
                    this.btn_elearn.Visible = true;

                    if (!(result.passStatus == PassResultStatus.Elearning || result.passStatus == PassResultStatus.Evaluation || result.passStatus == PassResultStatus.SurveyResult))
                    {
                        this.btn_PassCheck.Visible = true;
                    }
                }

                // パスワード不明ファイルがあれば、送信不可
                if (result.passStatus == PassResultStatus.Incorrect || result.passStatus == PassResultStatus.ProtecteZip)
                {
                    this.label1.Text = "パスワードを使用しているファイルがあります。監査隊へ通知が必要です。\n\n" +
    "①　パスワード使用を自動で通知\n" +
    "　　パスワード欄にパスワードを入力し、「パスワード検証」を押してください。問題なければ送信ボタンが表示され、送信ボタンを押すと監査隊へ自動でパスワードが通知されます。\n\n" +
    "②　パスワード使用例外を自動で通知\n" +
    "　　対象のファイルの選択欄をチェックし「パスワード通知不要設定」を押してください。次に表示される例外条件の項目から選択してください。選択すると送信ボタンが表示され、送信ボタンを押すと監査隊へ自動でパスワード使用の例外として通知されます。\n\n" +
    "　不明な場合は監査隊通信班（８－６－４２４７４）へ連絡お願いします。";

                    //this.sendBtn.Enabled = false;
                    sendCheck = false;
                    break;
                }
            }

            // 送信可能時、標記アラート表示
            if (sendCheck)
            {
                //    keywordResults.Add(new KeywordResult(fileName: "ダミーPPT「秘標記」1234.pptx", imageName: "ppt.png", positionStr: "スライド4"));
                //    keywordResults.Add(new KeywordResult(fileName: "ダミーWord「秘標記」ssmt.docx", imageName: "word.png", positionStr: "ページ2"));
                if (this.resultHundler.GetDetectResults().Count > 0)
                {
                    this.aform = new AlertForm(resultHundler.GetDetectResults());
                    aform.ShowDialog();
                }

                
            }

            SetSendBtn();

        }

        //*************************************************************************************************
        //送信ボタンの有効、無効設定
        //*************************************************************************************************
        private void SetSendBtn()
        {
            if(this.nameTextBox.Text == "" ||
                this.telTextBox1.Text == "" ||
                this.telTextBox2.Text == "" ||
                sendCheck == false)
            {
                this.sendBtn.Enabled = false;
            }
            else
            {
                this.sendBtn.Enabled = true;
            }
        }

        //*************************************************************************************************
        //送信ボタンを押したとき
        //*************************************************************************************************
        private void sendBtn_Click(object sender, EventArgs e)
        {
            List<PassResult> results = resultHundler.GetPassResults();

            //送信直前のパスワード入力をresultsに反映（送信可能時編集できるのはUnknownのみ）
            for (int i = 0; i < dataGridView1.RowCount; i++)
            {
                results[i].pwd = (string)dataGridView1.Rows[i].Cells[3].Value;
            }

            //オリジナルヘッダー組み立て
            string headerStr = "";
            foreach (PassResult result in results)
            {
                //通知が必要なもの
                if ((result.passStatus == PassResultStatus.Correct || result.passStatus == PassResultStatus.Elearning || result.passStatus == PassResultStatus.Unknown || result.passStatus == PassResultStatus.ProtecteZip) && result.pwd != "")
                {
                    //追加の場合は区切り文字をはさむ
                    if(headerStr.Length > 0)
                    {
                        headerStr += ",";
                    }
                    headerStr += "\"" + result.fName + "\":\"" + result.pwd + "\"";
                }
            }

            //オリジナルヘッダーが空でなければ
            if (headerStr.Length > 0)
            {
                //通知フォームでの補助通知を行う（暫定処置）
                _ = NoticePost(headerStr,
                                GetSenderSMTPAddress(),
                                mail.Subject,
                                Properties.Settings.Default.senderName,
                                Properties.Settings.Default.senderTle0 + "-" + Properties.Settings.Default.senderTel + "-" + Properties.Settings.Default.senderTel2);

                //送信者氏階級、内線番号追加
                headerStr = "{\"Sender\":\"" + Properties.Settings.Default.senderName + "("+ Properties.Settings.Default.senderTle0 + "-" + Properties.Settings.Default.senderTel + "-" + Properties.Settings.Default.senderTel2 + ")\"," + headerStr + "}";

                //暗号化してヘッダーに埋め込む場合
                Microsoft.Office.Interop.Outlook.PropertyAccessor oPA = mail.PropertyAccessor;
                String authHeader = "http://schemas.microsoft.com/mapi/string/{00020386-0000-0000-C000-000000000046}/x-auth"; //独自ヘッダ（X-auth）追加用


                //テスト用共通鍵での暗号化
                string AES_IV = @"pf69DL6GrWFyZcMK";
                string AES_Key = @"9Fix4L4HB4PKeKWY";
                headerStr = CryptAES.Encrypt(headerStr, AES_IV, AES_Key) + "AuthEnd";
                
                oPA.SetProperty(authHeader, headerStr);

                //終了処理
                Finishu();

            }

        }

        //*************************************************************************************************
        //通知メールを直接送る
        //*************************************************************************************************
        private void SendMail(string headerStr, string senderSMTPAddress, string subject, string senderName, string senderTel)
        {
            Outlook.MailItem mailItem = outlookApp.CreateItem(Outlook.OlItemType.olMailItem);
            if (mailItem != null)
            {

                string bodyStr = "";
                bodyStr = bodyStr.Append("①理由\n");
                bodyStr = bodyStr.Append("AutoPost by tool\n\n");
                bodyStr = bodyStr.Append("②あなたのアドレス(送信者)\n");
                bodyStr = bodyStr.Append(senderSMTPAddress + "\n件名：" + subject + "\n\n");
                bodyStr = bodyStr.Append("③あなたの所属及び氏階級\n");
                bodyStr = bodyStr.Append(senderName + "\n\n");
                bodyStr = bodyStr.Append("⑥添付ファイルのパスワード\n");
                bodyStr = bodyStr.Append(headerStr + "\n\n");
                bodyStr = bodyStr.Append("⑦内線番号\n");
                bodyStr = bodyStr.Append(senderTel + "\n\n");

                //To
                Outlook.Recipient to = mailItem.Recipients.Add("kansa-gsdf1@dii.js.mod.go.jp");
                //Outlook.Recipient to = mailItem.Recipients.Add("test@test.dev");
                to.Type = (int)Outlook.OlMailRecipientType.olTo;

                //件名
                mailItem.Subject = "パスワード事前通知";

                //本文
                mailItem.BodyFormat = Outlook.OlBodyFormat.olFormatPlain;
                mailItem.Body = bodyStr;


                //送信
                mailItem.Send();
            }
        }


        //*************************************************************************************************
        //通知フォームによる補助通知を行う（別タスク）
        //*************************************************************************************************
        private async Task NoticePost(string headerStr, string senderSMTPAddress, string subject, string senderName, string senderTel)
        {
            List<KeyValuePair<string, string>> paramaters = new List<KeyValuePair<string, string>>();
            try
            {

                //事前使用通知フォームへのデバッグ用確認画面へのポスト
                //paramaters.Add(new KeyValuePair<string, string>("sendmail", "kansa-gsdf1@dii.js.mod.go.jp"));
                //paramaters.Add(new KeyValuePair<string, string>("subject", "パスワード事前通知"));
                //paramaters.Add(new KeyValuePair<string, string>("re_message", "gsdfsapass.txt"));
                //paramaters.Add(new KeyValuePair<string, string>("_reason", "①理由"));
                //paramaters.Add(new KeyValuePair<string, string>("reason", "AutoPost by tool"));
                //paramaters.Add(new KeyValuePair<string, string>("_adress", "②あなたのアドレス(送信者)"));
                //paramaters.Add(new KeyValuePair<string, string>("adress", mail.SenderEmailAddress));
                //paramaters.Add(new KeyValuePair<string, string>("_force", "③あなたの所属及び氏階級"));
                //paramaters.Add(new KeyValuePair<string, string>("force", Properties.Settings.Default.senderName));
                //paramaters.Add(new KeyValuePair<string, string>("_partner", "④相手先(受信者)"));
                //paramaters.Add(new KeyValuePair<string, string>("partner", "NoData"));
                //paramaters.Add(new KeyValuePair<string, string>("_days", "⑤いつ、何回メールを送りますか"));
                //paramaters.Add(new KeyValuePair<string, string>("days", "Nodata"));
                //paramaters.Add(new KeyValuePair<string, string>("_pass", "⑥添付ファイルのパスワード"));
                //paramaters.Add(new KeyValuePair<string, string>("pass", headerStr));
                //paramaters.Add(new KeyValuePair<string, string>("_Tel", "⑦内線番号"));
                //paramaters.Add(new KeyValuePair<string, string>("Tel", "8-" + Properties.Settings.Default.senderTel + "-" + Properties.Settings.Default.senderTel2));
                //paramaters.Add(new KeyValuePair<string, string>("_person", "⑧部隊等情報保証責任者"));
                //paramaters.Add(new KeyValuePair<string, string>("parson", "Nodata"));
                //paramaters.Add(new KeyValuePair<string, string>("_etc", "⑨その他補足事項"));
                //paramaters.Add(new KeyValuePair<string, string>("etc", ""));

                paramaters.Add(new KeyValuePair<string, string>("sendmail", "kansa-gsdf1@dii.js.mod.go.jp"));
                paramaters.Add(new KeyValuePair<string, string>("subject", "パスワード事前通知"));
                paramaters.Add(new KeyValuePair<string, string>("re_message", "gsdfsapass.txt"));
                paramaters.Add(new KeyValuePair<string, string>("app_mail", ""));
                paramaters.Add(new KeyValuePair<string, string>("2", "①理由"));
                paramaters.Add(new KeyValuePair<string, string>("2", "AutoPost by tool"));
                paramaters.Add(new KeyValuePair<string, string>("4", "②あなたのアドレス(送信者)"));
                paramaters.Add(new KeyValuePair<string, string>("4", senderSMTPAddress));
                //paramaters.Add(new KeyValuePair<string, string>("4", senderSMTPAddress));
                paramaters.Add(new KeyValuePair<string, string>("6", "③あなたの所属及び氏階級"));
                paramaters.Add(new KeyValuePair<string, string>("6", senderName));
                paramaters.Add(new KeyValuePair<string, string>("8", "④相手先(受信者)"));
                paramaters.Add(new KeyValuePair<string, string>("8", "NoData"));
                paramaters.Add(new KeyValuePair<string, string>("10", "⑤いつ、何回メールを送りますか"));
                paramaters.Add(new KeyValuePair<string, string>("10", "Nodata"));
                paramaters.Add(new KeyValuePair<string, string>("12", "⑥添付ファイルのパスワード"));
                paramaters.Add(new KeyValuePair<string, string>("12", headerStr));
                paramaters.Add(new KeyValuePair<string, string>("14", "⑦内線番号"));
                paramaters.Add(new KeyValuePair<string, string>("14", senderTel));
                paramaters.Add(new KeyValuePair<string, string>("16", "⑧部隊等情報保証責任者"));
                paramaters.Add(new KeyValuePair<string, string>("16", "Nodata"));

                string query_string = "";
                byte[] data1 = null;
                byte[] data2 = null;
                string data3 = null;

                foreach (KeyValuePair<string, string> kvp in paramaters)
                {
                    if (query_string != "")
                    {
                        query_string += "&";
                    }
                    data1 = Encoding.GetEncoding("shift-jis").GetBytes(kvp.Value);
                    data2 = WebUtility.UrlEncodeToBytes(data1, 0, data1.Length);
                    data3 = Encoding.GetEncoding("shift-jis").GetString(data2, 0, data2.Length);
                    query_string += kvp.Key + "=" + data3;
                }
                HttpContent content = new StringContent(query_string);
                content.Headers.ContentType = new System.Net.Http.Headers.MediaTypeHeaderValue("application/x-www-form-urlencoded");

                using (var client = new HttpClient())
                {
                    System.Net.ServicePointManager.SecurityProtocol = System.Net.SecurityProtocolType.Tls12 | System.Net.SecurityProtocolType.Tls11 | System.Net.SecurityProtocolType.Tls;
                    //var response = await client.PostAsync($"https://web.dii.mod.go.jp/cgi-bin/FPMA3202.cgi", content);
                    var response = await client.PostAsync($"https://web.dii.mod.go.jp/cgi-bin/FPMA3203.cgi", content);

                    //デバッグ用レスポンス書き出し確認
                    //var encode = Encoding.GetEncoding("shift-jis");
                    //using(var stream = await response.Content.ReadAsStreamAsync())
                    //using(var reader = new StreamReader(stream, encode, true) as TextReader)
                    //{
                    //    using (StreamWriter writer = new System.IO.StreamWriter(ThisAddIn.WORK_FOLDER_PATH + "respons.txt"))
                    //    {
                    //        writer.Write(await response.Content.ReadAsStringAsync());
                    //    }
                    //}
                }
            }
            catch (System.Exception teste)
            {
                //MessageBox.Show("【検証用メッセージ】メールによる補助通知の送信に失敗しました。事前通知フォームにアクセスできません。実際にパスワード付きメールを送付している場合には、通信班に一報ください。また、検証のため次に表示されるエラーメッセージのスクリーンショット保存をお願いします。");
                //MessageBox.Show(teste.ToString());
                //フォームによる通知に失敗した場合、メールにより通知する
                SendMail(headerStr, senderSMTPAddress, subject, senderName, senderTel);
            }

        }

        //*************************************************************************************************
        //送信者アドレスの取得
        //*************************************************************************************************
        private string GetSenderSMTPAddress()
        {
            //string PR_SMTP_ADDRESS = @"http://schemas.microsoft.com/mapi/proptag/0x39FE001E";

            try
            {
                Outlook.AddressEntry addrEntry = outlookApp.Session.CurrentUser.AddressEntry;
                if (addrEntry.Type == "EX")
                {
                    Outlook.ExchangeUser currentUser = outlookApp.Session.CurrentUser.AddressEntry.GetExchangeUser();
                    if (currentUser != null)
                    {
                        return currentUser.PrimarySmtpAddress;
                    }
                    else
                    {
                        return "Nodata";
                    }
                }
                else
                {
                    return mail.SenderEmailAddress;
                    //return outlookApp.Session.CurrentUser.PropertyAccessor.GetProperties(PR_SMTP_ADDRESS) as string;
                }
            }
            catch(Exception e)
            {
                MessageBox.Show(e.ToString());
                return "Nodata";
            }

        }

        //*************************************************************************************************
        //添付ファイル等の一時ファイルフォルダの初期化
        //*************************************************************************************************
        private void ClearWorkDir()
        {
            if (Directory.Exists(ThisAddIn.WORK_FOLDER_PATH))
            {
                try
                {
                    DirectoryInfo di = new DirectoryInfo(ThisAddIn.WORK_FOLDER_PATH);
                    RemoveReadOnlyAttribute(di);
                    di.Delete(true);
                }catch
                {
                    // エラー処理なし？
                }
            }
            Directory.CreateDirectory(ThisAddIn.WORK_FOLDER_PATH);
        }

        //*************************************************************************************************
        //ReadOnly属性除去（一時ファイルの削除前の下処理用）（再帰呼び出し）
        //*************************************************************************************************
        public void RemoveReadOnlyAttribute(DirectoryInfo di)
        {
            if ((di.Attributes & FileAttributes.ReadOnly) == FileAttributes.ReadOnly) di.Attributes = FileAttributes.Normal;
            foreach (FileInfo fi in di.GetFiles()) if ((fi.Attributes & FileAttributes.ReadOnly) == FileAttributes.ReadOnly) fi.Attributes = FileAttributes.Normal;
            foreach (DirectoryInfo subDi in di.GetDirectories()) RemoveReadOnlyAttribute(subDi);
        }

        //*************************************************************************************************
        //×ボタン、キャンセルボタン、送信者情報を保存して終了
        //*************************************************************************************************
        private void Cancelbtn_Click(object sender, EventArgs e)
        {
            Finishu();
        }

        //*************************************************************************************************
        //終了時の後処理
        //*************************************************************************************************
        private void Finishu()
        {
            ClearWorkDir(); //一時作業フォルダクリア
            checker.Close();
        }

        //*************************************************************************************************
        //ヘルプボタン、とりあえず通信監査掲示板にとばす
        //*************************************************************************************************
        private void helpBtn_Click(object sender, EventArgs e)
        {
            //ブラウザで開く
            System.Diagnostics.Process.Start("https://cc-n.gbase.gsdf.mod.go.jp/cc/Monit-portal/signal/Lists/質問掲示板/NewForm.aspx");
        }


        //*************************************************************************************************
        //セル入力時にIME無効
        //*************************************************************************************************
        private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
        {
            dataGridView1.ImeMode = System.Windows.Forms.ImeMode.Disable;
        }

        //*************************************************************************************************
        //パスワード列のセル選択時、DeleteかBackSpaceでセル消去、ctrl+vによる貼付け
        //*************************************************************************************************
        private void dataGridView1_KeyDown(object sender, KeyEventArgs e)
        {
            //　パスワード列のセル選択時、DeleteかBackSpaceでセル消去
            if (e.KeyCode == Keys.Delete || e.KeyCode == Keys.Back)
            {
                foreach (DataGridViewCell cell in dataGridView1.SelectedCells)
                {
                    if (!cell.ReadOnly && cell.ColumnIndex == 3)
                    {
                        cell.Value = "";
                    }
                }
            }

            //　パスワード列のセル選択時、ctrl + v でクリップボードから貼付け
            if (e.Control && e.KeyCode == Keys.V)
            {
                foreach (DataGridViewCell cell in dataGridView1.SelectedCells)
                {
                    if (!cell.ReadOnly && cell.ColumnIndex == 3)
                    {
                        cell.Value = Clipboard.GetText();
                    }
                }
            }
        }


        private void ResultForm_Load(object sender, EventArgs e)
        {

        }

        //*************************************************************************************************
        // 送信者情報が編集されたら保存
        //*************************************************************************************************
        private void nameTextBox_TextChanged(object sender, EventArgs e)
        {
            if (senderLoaded)
            {
                Properties.Settings.Default.senderName = this.nameTextBox.Text;
                Properties.Settings.Default.senderTle0 = this.telTextBox0.Text;
                Properties.Settings.Default.senderTel = this.telTextBox1.Text;
                Properties.Settings.Default.senderTel2 = this.telTextBox2.Text;
                Properties.Settings.Default.Save(); //設定保存
                //MessageBox.Show("保存");

                SetSendBtn();
            }
        }


        //*************************************************************************************************
        // グリッドビューをクリアしデータを表示する
        //*************************************************************************************************
        public void ViewResult()
        {
            List<PassResult> results = resultHundler.GetPassResults();

            this.dataGridView1.Rows.Clear();
            DataGridViewRow[] rows = new DataGridViewRow[results.Count];
            for (int i = 0; i < results.Count; i++)
            {
                string msgStr = "";
                switch (results[i].passStatus)
                {
                    case PassResultStatus.NonePassword:
                        msgStr = "パスワードはありません。";
                        break;
                    case PassResultStatus.Correct:
                        msgStr = "【パスワード確認】監査隊へ使用通知をします。";
                        break;
                    case PassResultStatus.Incorrect:
                        msgStr = "【パスワード不明】正しいパスワードを入れ再度検証してください。";
                        break;
                    case PassResultStatus.Unknown:
                        msgStr = "【非対応ファイル形式】通知を行う必要がある場合は、パスワードを入力してから送信してください。";
                        break;
                    case PassResultStatus.Unzipped:
                        msgStr = "ZIPファイルまたはMSGファイルです。";
                        break;
                    case PassResultStatus.Elearning:
                        msgStr = "【人事評価記録】パスワード通知不要ファイルとして監査隊に通知します。";
                        break;
                    case PassResultStatus.Evaluation:
                        msgStr = "【ｅラーニング等】パスワード通知不要ファイルとして監査隊に通知します。";
                        break;
                    case PassResultStatus.SurveyResult:
                        msgStr = "【調査等のデータ】パスワード通知不要ファイルとして監査隊に通知します。";
                        break;
                    case PassResultStatus.ProtecteZip:
                        msgStr = "【パスワード不明】正しいパスワードを入れ再度検証してください。";
                        break;
                    case PassResultStatus.Object:
                        msgStr = "【埋め込みオブジェクト】本文埋め込みのオブジェクトです。対応しません。";
                        break;
                    default:
                        msgStr = "result.statusが例外です。";
                        break;
                }
                object[] cellValues = new object[]{
                                        results[i].indexNum,
                                        false,
                                        results[i].fName,
                                        results[i].pwd,
                                        results[i].passStatus,
                                        msgStr
                                        };

                DataGridViewRow row = new DataGridViewRow();
                row.CreateCells(this.dataGridView1);
                row.SetValues(cellValues);


                // パスワード欄の入力可否切り替え
                if (results[i].passStatus == PassResultStatus.Unknown)
                {
                    row.Cells[3].ReadOnly = false; //非対応の場合、パスワード入力可能
                }
                else if (results[i].passStatus == PassResultStatus.Incorrect)
                {
                    row.Cells[3].ReadOnly = false; //パスワード不一致の場合の入力可能
                }
                else if (results[i].passStatus == PassResultStatus.ProtecteZip)
                {
                    row.Cells[3].ReadOnly = false; //パスワード保護Zipの場合の入力可能
                }
                else
                {
                    row.Cells[3].ReadOnly = true; //それ以外のパスワード欄編集不可
                }

                // パスワード不明、パスワード保護Zip行の赤文字設定
                if (results[i].passStatus == PassResultStatus.Incorrect || results[i].passStatus == PassResultStatus.ProtecteZip)
                {
                    row.DefaultCellStyle.ForeColor = System.Drawing.Color.Red;
                }
                else
                {
                    row.DefaultCellStyle.ForeColor = System.Drawing.Color.Black;
                }

                rows[i] = row;
            }
            this.dataGridView1.Rows.AddRange(rows);
        }


        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void pnl_body_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
