﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Extentions;
using Microsoft.Office.Interop.Excel;

namespace PasswordCheck
{
    class Keyword
    {
        //チェック対象の文字列最大の長さ
        public const int MAX_TEXT_LENGTH = 15;

        HashSet<string> classificationWords;
        List<string> secretWords;
        public Keyword()
        {

            classificationWords = new HashSet<string>(StringComparer.OrdinalIgnoreCase)
            {
                "秘",
                "指定前秘",
                "特定秘密",
                "secret",
                "confidential"
            };

            secretWords = new List<string>();
            secretWords.Add("諸元");
        }

        public string CheckClassificationWords(string text)
        {
            //null、長文は判定しない
            if (text == null || text.Length > MAX_TEXT_LENGTH)
            {
                return null;
            }
            //空白の除去
            text = text.RemoveAllSpace().ToLower();

            //textが完全一致するものがあるかチェック
            if (classificationWords.Contains(text))
            {
                //MessageBox.Show("検知");
                return text;
            }
            return null;
        }
    }
}