﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PasswordCheck
{
    //*************************************************************************************************
    // enum宣言
    //*************************************************************************************************
    public enum PassResultStatus
    {
        Undefined, //未確認（初期値）
        Unknown, //例外ファイル（想定されていないファイル形式）
        NonePassword, //パスワードなし
        Correct, //パスワード特定
        Incorrect, //パスワード不一致
        Zipped, //圧縮ファイル
        Unzipped, //展開済み圧縮ファイル
        ProtecteZip, //パスワード保護されたZip(非対応)
        SecPdf, //パスワード付きPDF
        Object, //処理できない埋め込みオブジェクト
        Evaluation, //人事評価（監査不要ファイル１）
        Elearning, //ｅラーニング（監査不要ファイル２）
        SurveyResult //調査結果（監査不要ファイル３）
    }

    public enum SeachResultStatus
    {
        Untouched,//未実施
        Finished //検索済み
        //Notdetected,//実施済み（対象なし）
        //Detected//実施済み（対象あり）
    }

    public enum FileType
    {
        Word,
        WordXML,
        Excel,
        ExcelXML,
        PowerPoint,
        PowerPointXML,
        Zip,
        Msg,
        Eml,
        Pdf,
        Other,
        Unknown
    }

    //*************************************************************************************************
    // パスワードチェック結果の宣言
    //*************************************************************************************************
    public class PassResult
    {   // 結果データのパラメータ定義
        public int indexNum; public string fName; public string pwd; public PassResultStatus passStatus; public FileType fType; public SeachResultStatus seachStatus; 
        public PassResult(string fileName,
                          int Num = -1,
                          string password = "",
                          PassResultStatus rStatus = PassResultStatus.Undefined,
                          SeachResultStatus sStatus = SeachResultStatus.Untouched,
                          FileType type = FileType.Unknown)
        {
            indexNum = Num;
            fName = fileName;
            pwd = password;
            passStatus = rStatus;
            seachStatus = sStatus;
            fType = type;
        }
    }

    //*************************************************************************************************
    // キーワードチェック結果の宣言
    //*************************************************************************************************
    public class DetectResult
    {   // 結果データのパラメータ定義
        public int indexNum; public string fName; public string kword; public string imgName; public string pStr; public bool imgEx;
        public DetectResult(string fileName = "",
                             string keyword = "",
                             int Num = -1,
                             bool imgExist = false,
                             string imageName = "",
                             string positionStr = "")
        {
            indexNum = Num;
            fName = fileName;
            kword = keyword;
            imgName = imageName;
            pStr = positionStr;
            imgEx = imgExist;
        }

    }

}