﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.Windows.Forms;
using Office = Microsoft.Office.Core;

namespace PasswordCheck
{
    public partial class ThisAddIn
    {
        Outlook.Inspectors inspectors;
        static public string OUTLOOK_FOLDER_PATH = System.Environment.GetFolderPath(System.Environment.SpecialFolder.InternetCache) + @"\Content.Outlook\";
        static public string WORK_FOLDER_PATH = OUTLOOK_FOLDER_PATH + @"WORK\";

        private void ThisAddIn_Startup(object sender, System.EventArgs e)
        {
            inspectors = this.Application.Inspectors;
            inspectors.NewInspector += new Outlook.InspectorsEvents_NewInspectorEventHandler(Inspectors_NewInspector);
            Application.ItemSend += new Outlook.ApplicationEvents_11_ItemSendEventHandler(Application_ItemSend);
        }

        void Inspectors_NewInspector(Microsoft.Office.Interop.Outlook.Inspector inspector)
        {
            Outlook.MailItem mailItem = inspector.CurrentItem as Outlook.MailItem;
            if (mailItem != null)
            {
                if (mailItem.EntryID == null)
                {
                    //開発作業用（用済み削除）
                    //mailItem.To = "test@test.dev";
                    //mailItem.Subject = "Outlookアドイン送信テスト";

                    Microsoft.Office.Interop.Outlook.PropertyAccessor oPA = mailItem.PropertyAccessor;

                }
            }
        }

        public void Application_ItemSend(object Item, ref bool Cancel)
        {
            //MessageBox.Show(this.Application.Session.CurrentUser.Address);
            Cancel = true; //異常終了時に送信しない
            Outlook.MailItem mail = Item as Outlook.MailItem; //メールのみ対応

            
            if (mail.Attachments.Count > 0)
            {
                ResultForm form = new ResultForm(this.Application, mail);
                if (form.ShowDialog() == DialogResult.OK)
                {
                    Cancel = false; // 送信ボタンが押されたとき
                }
            }
            else
            {
                Cancel = false; //添付ファイルなしはそのまま送信
            }

        }





        private void ThisAddIn_Shutdown(object sender, System.EventArgs e)
        {
            //注: Outlook はこのイベントを発行しなくなりました。Outlook が
            //    を Outlook のシャットダウン時に実行する必要があります。https://go.microsoft.com/fwlink/?LinkId=506785 をご覧ください
        }

            #region VSTO で生成されたコード

            /// <summary>
            /// デザイナーのサポートに必要なメソッドです。
            /// このメソッドの内容をコード エディターで変更しないでください。
            /// </summary>
            private void InternalStartup()
        {
            this.Startup += new System.EventHandler(ThisAddIn_Startup);
            this.Shutdown += new System.EventHandler(ThisAddIn_Shutdown);
        }
        
        #endregion
    }
}