﻿using System;
using System.IO;

public static class Logger
{
    public enum LogLevel
    {
        INFO,
        ERROR,
        DEBUG
    }

    public static void Log(string message, LogLevel level = LogLevel.INFO)
    {
        #if DEBUG
        try
        {
            // ログファイルのパスを設定。例: "Logs/log_2024-03-19.txt"
            string logDirectory = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Logs");
            string logFileName = $"log_{DateTime.Now.ToString("yyyy-MM-dd")}.txt";
            string logFilePath = Path.Combine(logDirectory, logFileName);

            // ログディレクトリが存在しない場合は作成
            if (!Directory.Exists(logDirectory))
            {
                Directory.CreateDirectory(logDirectory);
            }

            // ログメッセージのフォーマット
            string logMessage = $"{DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")} [{level.ToString()}] {message}\n";

            // ログファイルにメッセージを追記
            File.AppendAllText(logFilePath, logMessage);
        }
        catch (Exception ex)
        {
            // ログの書き込みに失敗した場合のエラーハンドリング
            Console.WriteLine($"ログの書き込みに失敗しました: {ex.Message}");
        }
#endif
    }
}
